class City
  def initialize(resources = {})
    resources.each_key do |resource|
      City.add_resource(resource) unless respond_to?("increment_#{resource}!")
      instance_variable_set("@#{resource}", resources[resource])
    end
  end

  def self.add_resource(resource)
    attr_reader resource

    define_method "increment_#{resource}!" do
      instance_variable_set("@#{resource}", send(resource) + 1)
    end

    define_method "decrement_#{resource}!" do
      instance_variable_set("@#{resource}", send(resource) - 1)
    end
  end
end

c = City.new a: 42, b: 23, c: 73

puts "a: #{c.a}, b: #{c.b}, c: #{c.c}"
c.increment_a!
c.decrement_b!
puts "a: #{c.a}, b: #{c.b}, c: #{c.c}"
